/*
 * Qcint is a general GTO integral library for computational chemistry
 * Copyright (C) 2014- Qiming Sun <osirpt.sun@gmail.com>
 *
 * This file is part of Qcint.
 *
 * Qcint is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Description: code generated by  gen-code.cl
 */
#include <pmmintrin.h>
#include <stdlib.h>
#include "cint_bas.h"
#include "cart2sph.h"
#include "g2e.h"
#include "g3c2e.h"
#include "g2c2e.h"
#include "optimizer.h"
#include "cint1e.h"
#include "cint2e.h"
#include "misc.h"
#include "fblas.h"
#include "c2f.h"
/* <NABLA i|OVLP |j> */
static void CINTgout1e_cint1e_ipovlp(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
G1E_D_I(g1, g0, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout += 3;
}}
FINT cint1e_ipovlp(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ipovlp;
return CINT1e_drv(opij, &envs, 1, &c2s_sf_1e); }
C2F_(cint1e_ipovlp)
/* <NABLA i|OVLP |P DOT P j> */
static void CINTgout1e_cint1e_ipkin(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double s[27];
G1E_D_J(g1, g0, i_l+1, j_l+0);
G1E_D_J(g2, g0, i_l+1, j_l+1);
G1E_D_J(g3, g2, i_l+1, j_l+0);
G1E_D_I(g4, g0, i_l+0, j_l);
G1E_D_I(g5, g1, i_l+0, j_l);
G1E_D_I(g6, g2, i_l+0, j_l);
G1E_D_I(g7, g3, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g7[ix] * g0[iy] * g0[iz];
s[1] = g6[ix] * g1[iy] * g0[iz];
s[2] = g6[ix] * g0[iy] * g1[iz];
s[3] = g5[ix] * g2[iy] * g0[iz];
s[4] = g4[ix] * g3[iy] * g0[iz];
s[5] = g4[ix] * g2[iy] * g1[iz];
s[6] = g5[ix] * g0[iy] * g2[iz];
s[7] = g4[ix] * g1[iy] * g2[iz];
s[8] = g4[ix] * g0[iy] * g3[iz];
s[9] = g3[ix] * g4[iy] * g0[iz];
s[10] = g2[ix] * g5[iy] * g0[iz];
s[11] = g2[ix] * g4[iy] * g1[iz];
s[12] = g1[ix] * g6[iy] * g0[iz];
s[13] = g0[ix] * g7[iy] * g0[iz];
s[14] = g0[ix] * g6[iy] * g1[iz];
s[15] = g1[ix] * g4[iy] * g2[iz];
s[16] = g0[ix] * g5[iy] * g2[iz];
s[17] = g0[ix] * g4[iy] * g3[iz];
s[18] = g3[ix] * g0[iy] * g4[iz];
s[19] = g2[ix] * g1[iy] * g4[iz];
s[20] = g2[ix] * g0[iy] * g5[iz];
s[21] = g1[ix] * g2[iy] * g4[iz];
s[22] = g0[ix] * g3[iy] * g4[iz];
s[23] = g0[ix] * g2[iy] * g5[iz];
s[24] = g1[ix] * g0[iy] * g6[iz];
s[25] = g0[ix] * g1[iy] * g6[iz];
s[26] = g0[ix] * g0[iy] * g7[iz];
gout[0] += + (-1*s[0]) + (-1*s[4]) + (-1*s[8]);
gout[1] += + (-1*s[9]) + (-1*s[13]) + (-1*s[17]);
gout[2] += + (-1*s[18]) + (-1*s[22]) + (-1*s[26]);
gout += 3;
}}
FINT cint1e_ipkin(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 2, 0, 0, 3, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ipkin;
return CINT1e_drv(opij, &envs, 0.5, &c2s_sf_1e); }
C2F_(cint1e_ipkin)
/* <NABLA i|NUC |j> */
static void CINTgout1e_cint1e_ipnuc(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
G1E_D_I(g1, g0, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout += 3;
}}
FINT cint1e_ipnuc(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ipnuc;
return CINT1e_nuc_drv(opij, &envs, 1, &c2s_sf_1e); }
C2F_(cint1e_ipnuc)
/* <NABLA i|RINV |j> */
static void CINTgout1e_cint1e_iprinv(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double s[3];
G1E_D_I(g1, g0, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g1[ix] * g0[iy] * g0[iz];
s[1] = g0[ix] * g1[iy] * g0[iz];
s[2] = g0[ix] * g0[iy] * g1[iz];
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout += 3;
}}
FINT cint1e_iprinv(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_iprinv;
return CINT1e_rinv_drv(opij, &envs, 1, &c2s_sf_1e); }
C2F_(cint1e_iprinv)
/* <NABLA SIGMA DOT P i|NUC |SIGMA DOT P j> */
static void CINTgout1e_cint1e_ipspnucsp(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double s[27];
G1E_D_J(g1, g0, i_l+2, j_l+0);
G1E_D_I(g2, g0, i_l+1, j_l);
G1E_D_I(g3, g1, i_l+1, j_l);
G1E_D_I(g4, g0, i_l+0, j_l);
G1E_D_I(g5, g1, i_l+0, j_l);
G1E_D_I(g6, g2, i_l+0, j_l);
G1E_D_I(g7, g3, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g7[ix] * g0[iy] * g0[iz];
s[1] = g6[ix] * g1[iy] * g0[iz];
s[2] = g6[ix] * g0[iy] * g1[iz];
s[3] = g5[ix] * g2[iy] * g0[iz];
s[4] = g4[ix] * g3[iy] * g0[iz];
s[5] = g4[ix] * g2[iy] * g1[iz];
s[6] = g5[ix] * g0[iy] * g2[iz];
s[7] = g4[ix] * g1[iy] * g2[iz];
s[8] = g4[ix] * g0[iy] * g3[iz];
s[9] = g3[ix] * g4[iy] * g0[iz];
s[10] = g2[ix] * g5[iy] * g0[iz];
s[11] = g2[ix] * g4[iy] * g1[iz];
s[12] = g1[ix] * g6[iy] * g0[iz];
s[13] = g0[ix] * g7[iy] * g0[iz];
s[14] = g0[ix] * g6[iy] * g1[iz];
s[15] = g1[ix] * g4[iy] * g2[iz];
s[16] = g0[ix] * g5[iy] * g2[iz];
s[17] = g0[ix] * g4[iy] * g3[iz];
s[18] = g3[ix] * g0[iy] * g4[iz];
s[19] = g2[ix] * g1[iy] * g4[iz];
s[20] = g2[ix] * g0[iy] * g5[iz];
s[21] = g1[ix] * g2[iy] * g4[iz];
s[22] = g0[ix] * g3[iy] * g4[iz];
s[23] = g0[ix] * g2[iy] * g5[iz];
s[24] = g1[ix] * g0[iy] * g6[iz];
s[25] = g0[ix] * g1[iy] * g6[iz];
s[26] = g0[ix] * g0[iy] * g7[iz];
gout[0] += + s[11] + (-1*s[19]);
gout[1] += + s[18] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[9]);
gout[3] += + s[0] + s[10] + s[20];
gout[4] += + s[14] + (-1*s[22]);
gout[5] += + s[21] + (-1*s[5]);
gout[6] += + s[4] + (-1*s[12]);
gout[7] += + s[3] + s[13] + s[23];
gout[8] += + s[17] + (-1*s[25]);
gout[9] += + s[24] + (-1*s[8]);
gout[10] += + s[7] + (-1*s[15]);
gout[11] += + s[6] + s[16] + s[26];
gout += 12;
}}
FINT cint1e_ipspnucsp(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ipspnucsp;
return CINT1e_nuc_drv(opij, &envs, 1, &c2s_si_1e); }
C2F_(cint1e_ipspnucsp)
/* <NABLA SIGMA DOT P i|RINV |SIGMA DOT P j> */
static void CINTgout1e_cint1e_ipsprinvsp(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
FINT ix, iy, iz, n;
double *g0 = g;
double *g1 = g0  + envs->g_size * 3;
double *g2 = g1  + envs->g_size * 3;
double *g3 = g2  + envs->g_size * 3;
double *g4 = g3  + envs->g_size * 3;
double *g5 = g4  + envs->g_size * 3;
double *g6 = g5  + envs->g_size * 3;
double *g7 = g6  + envs->g_size * 3;
double *g8 = g7  + envs->g_size * 3;
double s[27];
G1E_D_J(g1, g0, i_l+2, j_l+0);
G1E_D_I(g2, g0, i_l+1, j_l);
G1E_D_I(g3, g1, i_l+1, j_l);
G1E_D_I(g4, g0, i_l+0, j_l);
G1E_D_I(g5, g1, i_l+0, j_l);
G1E_D_I(g6, g2, i_l+0, j_l);
G1E_D_I(g7, g3, i_l+0, j_l);
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
s[0] = g7[ix] * g0[iy] * g0[iz];
s[1] = g6[ix] * g1[iy] * g0[iz];
s[2] = g6[ix] * g0[iy] * g1[iz];
s[3] = g5[ix] * g2[iy] * g0[iz];
s[4] = g4[ix] * g3[iy] * g0[iz];
s[5] = g4[ix] * g2[iy] * g1[iz];
s[6] = g5[ix] * g0[iy] * g2[iz];
s[7] = g4[ix] * g1[iy] * g2[iz];
s[8] = g4[ix] * g0[iy] * g3[iz];
s[9] = g3[ix] * g4[iy] * g0[iz];
s[10] = g2[ix] * g5[iy] * g0[iz];
s[11] = g2[ix] * g4[iy] * g1[iz];
s[12] = g1[ix] * g6[iy] * g0[iz];
s[13] = g0[ix] * g7[iy] * g0[iz];
s[14] = g0[ix] * g6[iy] * g1[iz];
s[15] = g1[ix] * g4[iy] * g2[iz];
s[16] = g0[ix] * g5[iy] * g2[iz];
s[17] = g0[ix] * g4[iy] * g3[iz];
s[18] = g3[ix] * g0[iy] * g4[iz];
s[19] = g2[ix] * g1[iy] * g4[iz];
s[20] = g2[ix] * g0[iy] * g5[iz];
s[21] = g1[ix] * g2[iy] * g4[iz];
s[22] = g0[ix] * g3[iy] * g4[iz];
s[23] = g0[ix] * g2[iy] * g5[iz];
s[24] = g1[ix] * g0[iy] * g6[iz];
s[25] = g0[ix] * g1[iy] * g6[iz];
s[26] = g0[ix] * g0[iy] * g7[iz];
gout[0] += + s[11] + (-1*s[19]);
gout[1] += + s[18] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[9]);
gout[3] += + s[0] + s[10] + s[20];
gout[4] += + s[14] + (-1*s[22]);
gout[5] += + s[21] + (-1*s[5]);
gout[6] += + s[4] + (-1*s[12]);
gout[7] += + s[3] + s[13] + s[23];
gout[8] += + s[17] + (-1*s[25]);
gout[9] += + s[24] + (-1*s[8]);
gout[10] += + s[7] + (-1*s[15]);
gout[11] += + s[6] + s[16] + s[26];
gout += 12;
}}
FINT cint1e_ipsprinvsp(double *opij, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_cint1e_ipsprinvsp;
return CINT1e_rinv_drv(opij, &envs, 1, &c2s_si_1e); }
C2F_(cint1e_ipsprinvsp)
/* <k NABLA i|R12 |j l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA i j|R12 |k l) */
static void CINTgout2e_cint2e_ip1(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double s[3];
G2E_D_I(g1, g0, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
switch (envs->nrys_roots) {
case 1:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
break;
case 2:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
break;
case 3:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
s[0] += g1[ix+2] * g0[iy+2] * g0[iz+2];
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
s[1] += g0[ix+2] * g1[iy+2] * g0[iz+2];
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
s[2] += g0[ix+2] * g0[iy+2] * g1[iz+2];
break;
case 4:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g1+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g1+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
break;
case 5:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g1+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
s[0] += g1[ix+4] * g0[iy+4] * g0[iz+4];
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g1+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
s[1] += g0[ix+4] * g1[iy+4] * g0[iz+4];
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
s[2] += g0[ix+4] * g0[iy+4] * g1[iz+4];
break;
case 6:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g1+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g1+ix+4);
r1 = _mm_load_pd(g0+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g1+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+4);
r1 = _mm_load_pd(g1+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+4);
r1 = _mm_load_pd(g0+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
break;
case 7:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g1+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g1+ix+4);
r1 = _mm_load_pd(g0+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
s[0] += g1[ix+6] * g0[iy+6] * g0[iz+6];
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g1+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+4);
r1 = _mm_load_pd(g1+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
s[1] += g0[ix+6] * g1[iy+6] * g0[iz+6];
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+4);
r1 = _mm_load_pd(g0+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
s[2] += g0[ix+6] * g0[iy+6] * g1[iz+6];
break;
default:
r0 = _mm_load_pd(g1+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g1+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g1+ix+4);
r1 = _mm_load_pd(g0+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g1+ix+6);
r1 = _mm_load_pd(g0+iy+6);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+6);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+0, r0);
for (i = 8; i < envs->nrys_roots; i++) {
s[0] += g1[ix+i] * g0[iy+i] * g0[iz+i];}
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g1+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g0+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g1+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+4);
r1 = _mm_load_pd(g1+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+6);
r1 = _mm_load_pd(g1+iy+6);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g0+iz+6);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+1, r0);
for (i = 8; i < envs->nrys_roots; i++) {
s[1] += g0[ix+i] * g1[iy+i] * g0[iz+i];}
r0 = _mm_load_pd(g0+ix  );
r1 = _mm_load_pd(g0+iy  );
r0 = _mm_mul_pd(r0, r1);
r1 = _mm_load_pd(g1+iz  );
r0 = _mm_mul_pd(r0, r1);
r2 = _mm_load_pd(g0+ix+2);
r1 = _mm_load_pd(g0+iy+2);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+2);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+4);
r1 = _mm_load_pd(g0+iy+4);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+4);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r2 = _mm_load_pd(g0+ix+6);
r1 = _mm_load_pd(g0+iy+6);
r2 = _mm_mul_pd(r2, r1);
r1 = _mm_load_pd(g1+iz+6);
r2 = _mm_mul_pd(r2, r1);
r0 = _mm_add_pd(r0, r2);
r0 = _mm_hadd_pd(r0, r0);
_mm_storeh_pd(s+2, r0);
for (i = 8; i < envs->nrys_roots; i++) {
s[2] += g0[ix+i] * g0[iy+i] * g1[iz+i];}
break;}
if (gout_empty) {
gout[0] = + s[0];
gout[1] = + s[1];
gout[2] = + s[2];
gout += 3;
} else {
gout[0] += + s[0];
gout[1] += + s[1];
gout[2] += + s[2];
gout += 3;
}}}
void cint2e_ip1_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ip1(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ip1;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_sf_2e1, &c2s_sf_2e2);
}
OPTIMIZER2F_(cint2e_ip1_optimizer);
C2Fo_(cint2e_ip1)
/* <k NABLA SIGMA DOT P i|R12 |SIGMA DOT P j l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT P i SIGMA DOT P j|R12 |k l) */
static void CINTgout2e_cint2e_ipspsp1(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double s[27];
G2E_D_J(g1, g0, i_l+2, j_l+0, k_l, l_l);
G2E_D_I(g2, g0, i_l+1, j_l, k_l, l_l);
G2E_D_I(g3, g1, i_l+1, j_l, k_l, l_l);
G2E_D_I(g4, g0, i_l+0, j_l, k_l, l_l);
G2E_D_I(g5, g1, i_l+0, j_l, k_l, l_l);
G2E_D_I(g6, g2, i_l+0, j_l, k_l, l_l);
G2E_D_I(g7, g3, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(27, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
if (gout_empty) {
gout[0] = + s[11] + (-1*s[19]);
gout[1] = + s[18] + (-1*s[2]);
gout[2] = + s[1] + (-1*s[9]);
gout[3] = + s[0] + s[10] + s[20];
gout[4] = + s[14] + (-1*s[22]);
gout[5] = + s[21] + (-1*s[5]);
gout[6] = + s[4] + (-1*s[12]);
gout[7] = + s[3] + s[13] + s[23];
gout[8] = + s[17] + (-1*s[25]);
gout[9] = + s[24] + (-1*s[8]);
gout[10] = + s[7] + (-1*s[15]);
gout[11] = + s[6] + s[16] + s[26];
gout += 12;
} else {
gout[0] += + s[11] + (-1*s[19]);
gout[1] += + s[18] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[9]);
gout[3] += + s[0] + s[10] + s[20];
gout[4] += + s[14] + (-1*s[22]);
gout[5] += + s[21] + (-1*s[5]);
gout[6] += + s[4] + (-1*s[12]);
gout[7] += + s[3] + s[13] + s[23];
gout[8] += + s[17] + (-1*s[25]);
gout[9] += + s[24] + (-1*s[8]);
gout[10] += + s[7] + (-1*s[15]);
gout[11] += + s[6] + s[16] + s[26];
gout += 12;
}}}
void cint2e_ipspsp1_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ipspsp1(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ipspsp1;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_si_2e1, &c2s_sf_2e2);
}
OPTIMIZER2F_(cint2e_ipspsp1_optimizer);
C2Fo_(cint2e_ipspsp1)
/* <SIGMA DOT P k NABLA i|R12 |j SIGMA DOT P l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA i j|R12 |SIGMA DOT P k SIGMA DOT P l) */
static void CINTgout2e_cint2e_ip1spsp2(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double s[27];
G2E_D_L(g1, g0, i_l+1, j_l+0, k_l+1, l_l+0);
G2E_D_K(g2, g0, i_l+1, j_l+0, k_l+0, l_l);
G2E_D_K(g3, g1, i_l+1, j_l+0, k_l+0, l_l);
G2E_D_I(g4, g0, i_l+0, j_l, k_l, l_l);
G2E_D_I(g5, g1, i_l+0, j_l, k_l, l_l);
G2E_D_I(g6, g2, i_l+0, j_l, k_l, l_l);
G2E_D_I(g7, g3, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(27, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
if (gout_empty) {
gout[0] = + s[5] + (-1*s[7]);
gout[1] = + s[6] + (-1*s[2]);
gout[2] = + s[1] + (-1*s[3]);
gout[3] = + s[0] + s[4] + s[8];
gout[4] = + s[14] + (-1*s[16]);
gout[5] = + s[15] + (-1*s[11]);
gout[6] = + s[10] + (-1*s[12]);
gout[7] = + s[9] + s[13] + s[17];
gout[8] = + s[23] + (-1*s[25]);
gout[9] = + s[24] + (-1*s[20]);
gout[10] = + s[19] + (-1*s[21]);
gout[11] = + s[18] + s[22] + s[26];
gout += 12;
} else {
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout[3] += + s[0] + s[4] + s[8];
gout[4] += + s[14] + (-1*s[16]);
gout[5] += + s[15] + (-1*s[11]);
gout[6] += + s[10] + (-1*s[12]);
gout[7] += + s[9] + s[13] + s[17];
gout[8] += + s[23] + (-1*s[25]);
gout[9] += + s[24] + (-1*s[20]);
gout[10] += + s[19] + (-1*s[21]);
gout[11] += + s[18] + s[22] + s[26];
gout += 12;
}}}
void cint2e_ip1spsp2_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ip1spsp2(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ip1spsp2;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_sf_2e1, &c2s_si_2e2);
}
OPTIMIZER2F_(cint2e_ip1spsp2_optimizer);
C2Fo_(cint2e_ip1spsp2)
/* <SIGMA DOT P k NABLA SIGMA DOT P i|R12 |SIGMA DOT P j SIGMA DOT P l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT P i SIGMA DOT P j|R12 |SIGMA DOT P k SIGMA DOT P l) */
static void CINTgout2e_cint2e_ipspsp1spsp2(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double s[243];
G2E_D_L(g1, g0, i_l+2, j_l+1, k_l+1, l_l+0);
G2E_D_K(g2, g0, i_l+2, j_l+1, k_l+0, l_l);
G2E_D_K(g3, g1, i_l+2, j_l+1, k_l+0, l_l);
G2E_D_J(g4, g0, i_l+2, j_l+0, k_l, l_l);
G2E_D_J(g5, g1, i_l+2, j_l+0, k_l, l_l);
G2E_D_J(g6, g2, i_l+2, j_l+0, k_l, l_l);
G2E_D_J(g7, g3, i_l+2, j_l+0, k_l, l_l);
G2E_D_I(g8, g0, i_l+1, j_l, k_l, l_l);
G2E_D_I(g9, g1, i_l+1, j_l, k_l, l_l);
G2E_D_I(g10, g2, i_l+1, j_l, k_l, l_l);
G2E_D_I(g11, g3, i_l+1, j_l, k_l, l_l);
G2E_D_I(g12, g4, i_l+1, j_l, k_l, l_l);
G2E_D_I(g13, g5, i_l+1, j_l, k_l, l_l);
G2E_D_I(g14, g6, i_l+1, j_l, k_l, l_l);
G2E_D_I(g15, g7, i_l+1, j_l, k_l, l_l);
G2E_D_I(g16, g0, i_l+0, j_l, k_l, l_l);
G2E_D_I(g17, g1, i_l+0, j_l, k_l, l_l);
G2E_D_I(g18, g2, i_l+0, j_l, k_l, l_l);
G2E_D_I(g19, g3, i_l+0, j_l, k_l, l_l);
G2E_D_I(g20, g4, i_l+0, j_l, k_l, l_l);
G2E_D_I(g21, g5, i_l+0, j_l, k_l, l_l);
G2E_D_I(g22, g6, i_l+0, j_l, k_l, l_l);
G2E_D_I(g23, g7, i_l+0, j_l, k_l, l_l);
G2E_D_I(g24, g8, i_l+0, j_l, k_l, l_l);
G2E_D_I(g25, g9, i_l+0, j_l, k_l, l_l);
G2E_D_I(g26, g10, i_l+0, j_l, k_l, l_l);
G2E_D_I(g27, g11, i_l+0, j_l, k_l, l_l);
G2E_D_I(g28, g12, i_l+0, j_l, k_l, l_l);
G2E_D_I(g29, g13, i_l+0, j_l, k_l, l_l);
G2E_D_I(g30, g14, i_l+0, j_l, k_l, l_l);
G2E_D_I(g31, g15, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(243, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g31[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g30[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g30[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g29[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g28[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g28[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g29[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g28[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g28[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g27[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g26[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g26[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g25[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g24[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g24[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g25[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g24[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g24[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g27[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g26[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g26[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g25[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g24[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g24[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g25[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g24[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g24[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g23[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g22[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g22[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g21[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g20[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g20[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g21[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g20[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g20[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g19[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g18[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g18[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g17[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g16[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g16[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g17[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g16[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g16[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g19[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g18[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g18[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g17[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g16[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g16[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g17[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g16[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g16[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g23[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g22[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g22[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g21[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g20[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g20[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g21[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g20[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g20[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g19[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g18[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g18[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g17[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g16[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g16[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g17[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g16[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g16[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g19[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g18[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g18[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g17[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g16[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g16[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g17[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g16[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g16[ix+i] * g0[iy+i] * g15[iz+i];
s[81] += g15[ix+i] * g16[iy+i] * g0[iz+i];
s[82] += g14[ix+i] * g17[iy+i] * g0[iz+i];
s[83] += g14[ix+i] * g16[iy+i] * g1[iz+i];
s[84] += g13[ix+i] * g18[iy+i] * g0[iz+i];
s[85] += g12[ix+i] * g19[iy+i] * g0[iz+i];
s[86] += g12[ix+i] * g18[iy+i] * g1[iz+i];
s[87] += g13[ix+i] * g16[iy+i] * g2[iz+i];
s[88] += g12[ix+i] * g17[iy+i] * g2[iz+i];
s[89] += g12[ix+i] * g16[iy+i] * g3[iz+i];
s[90] += g11[ix+i] * g20[iy+i] * g0[iz+i];
s[91] += g10[ix+i] * g21[iy+i] * g0[iz+i];
s[92] += g10[ix+i] * g20[iy+i] * g1[iz+i];
s[93] += g9[ix+i] * g22[iy+i] * g0[iz+i];
s[94] += g8[ix+i] * g23[iy+i] * g0[iz+i];
s[95] += g8[ix+i] * g22[iy+i] * g1[iz+i];
s[96] += g9[ix+i] * g20[iy+i] * g2[iz+i];
s[97] += g8[ix+i] * g21[iy+i] * g2[iz+i];
s[98] += g8[ix+i] * g20[iy+i] * g3[iz+i];
s[99] += g11[ix+i] * g16[iy+i] * g4[iz+i];
s[100] += g10[ix+i] * g17[iy+i] * g4[iz+i];
s[101] += g10[ix+i] * g16[iy+i] * g5[iz+i];
s[102] += g9[ix+i] * g18[iy+i] * g4[iz+i];
s[103] += g8[ix+i] * g19[iy+i] * g4[iz+i];
s[104] += g8[ix+i] * g18[iy+i] * g5[iz+i];
s[105] += g9[ix+i] * g16[iy+i] * g6[iz+i];
s[106] += g8[ix+i] * g17[iy+i] * g6[iz+i];
s[107] += g8[ix+i] * g16[iy+i] * g7[iz+i];
s[108] += g7[ix+i] * g24[iy+i] * g0[iz+i];
s[109] += g6[ix+i] * g25[iy+i] * g0[iz+i];
s[110] += g6[ix+i] * g24[iy+i] * g1[iz+i];
s[111] += g5[ix+i] * g26[iy+i] * g0[iz+i];
s[112] += g4[ix+i] * g27[iy+i] * g0[iz+i];
s[113] += g4[ix+i] * g26[iy+i] * g1[iz+i];
s[114] += g5[ix+i] * g24[iy+i] * g2[iz+i];
s[115] += g4[ix+i] * g25[iy+i] * g2[iz+i];
s[116] += g4[ix+i] * g24[iy+i] * g3[iz+i];
s[117] += g3[ix+i] * g28[iy+i] * g0[iz+i];
s[118] += g2[ix+i] * g29[iy+i] * g0[iz+i];
s[119] += g2[ix+i] * g28[iy+i] * g1[iz+i];
s[120] += g1[ix+i] * g30[iy+i] * g0[iz+i];
s[121] += g0[ix+i] * g31[iy+i] * g0[iz+i];
s[122] += g0[ix+i] * g30[iy+i] * g1[iz+i];
s[123] += g1[ix+i] * g28[iy+i] * g2[iz+i];
s[124] += g0[ix+i] * g29[iy+i] * g2[iz+i];
s[125] += g0[ix+i] * g28[iy+i] * g3[iz+i];
s[126] += g3[ix+i] * g24[iy+i] * g4[iz+i];
s[127] += g2[ix+i] * g25[iy+i] * g4[iz+i];
s[128] += g2[ix+i] * g24[iy+i] * g5[iz+i];
s[129] += g1[ix+i] * g26[iy+i] * g4[iz+i];
s[130] += g0[ix+i] * g27[iy+i] * g4[iz+i];
s[131] += g0[ix+i] * g26[iy+i] * g5[iz+i];
s[132] += g1[ix+i] * g24[iy+i] * g6[iz+i];
s[133] += g0[ix+i] * g25[iy+i] * g6[iz+i];
s[134] += g0[ix+i] * g24[iy+i] * g7[iz+i];
s[135] += g7[ix+i] * g16[iy+i] * g8[iz+i];
s[136] += g6[ix+i] * g17[iy+i] * g8[iz+i];
s[137] += g6[ix+i] * g16[iy+i] * g9[iz+i];
s[138] += g5[ix+i] * g18[iy+i] * g8[iz+i];
s[139] += g4[ix+i] * g19[iy+i] * g8[iz+i];
s[140] += g4[ix+i] * g18[iy+i] * g9[iz+i];
s[141] += g5[ix+i] * g16[iy+i] * g10[iz+i];
s[142] += g4[ix+i] * g17[iy+i] * g10[iz+i];
s[143] += g4[ix+i] * g16[iy+i] * g11[iz+i];
s[144] += g3[ix+i] * g20[iy+i] * g8[iz+i];
s[145] += g2[ix+i] * g21[iy+i] * g8[iz+i];
s[146] += g2[ix+i] * g20[iy+i] * g9[iz+i];
s[147] += g1[ix+i] * g22[iy+i] * g8[iz+i];
s[148] += g0[ix+i] * g23[iy+i] * g8[iz+i];
s[149] += g0[ix+i] * g22[iy+i] * g9[iz+i];
s[150] += g1[ix+i] * g20[iy+i] * g10[iz+i];
s[151] += g0[ix+i] * g21[iy+i] * g10[iz+i];
s[152] += g0[ix+i] * g20[iy+i] * g11[iz+i];
s[153] += g3[ix+i] * g16[iy+i] * g12[iz+i];
s[154] += g2[ix+i] * g17[iy+i] * g12[iz+i];
s[155] += g2[ix+i] * g16[iy+i] * g13[iz+i];
s[156] += g1[ix+i] * g18[iy+i] * g12[iz+i];
s[157] += g0[ix+i] * g19[iy+i] * g12[iz+i];
s[158] += g0[ix+i] * g18[iy+i] * g13[iz+i];
s[159] += g1[ix+i] * g16[iy+i] * g14[iz+i];
s[160] += g0[ix+i] * g17[iy+i] * g14[iz+i];
s[161] += g0[ix+i] * g16[iy+i] * g15[iz+i];
s[162] += g15[ix+i] * g0[iy+i] * g16[iz+i];
s[163] += g14[ix+i] * g1[iy+i] * g16[iz+i];
s[164] += g14[ix+i] * g0[iy+i] * g17[iz+i];
s[165] += g13[ix+i] * g2[iy+i] * g16[iz+i];
s[166] += g12[ix+i] * g3[iy+i] * g16[iz+i];
s[167] += g12[ix+i] * g2[iy+i] * g17[iz+i];
s[168] += g13[ix+i] * g0[iy+i] * g18[iz+i];
s[169] += g12[ix+i] * g1[iy+i] * g18[iz+i];
s[170] += g12[ix+i] * g0[iy+i] * g19[iz+i];
s[171] += g11[ix+i] * g4[iy+i] * g16[iz+i];
s[172] += g10[ix+i] * g5[iy+i] * g16[iz+i];
s[173] += g10[ix+i] * g4[iy+i] * g17[iz+i];
s[174] += g9[ix+i] * g6[iy+i] * g16[iz+i];
s[175] += g8[ix+i] * g7[iy+i] * g16[iz+i];
s[176] += g8[ix+i] * g6[iy+i] * g17[iz+i];
s[177] += g9[ix+i] * g4[iy+i] * g18[iz+i];
s[178] += g8[ix+i] * g5[iy+i] * g18[iz+i];
s[179] += g8[ix+i] * g4[iy+i] * g19[iz+i];
s[180] += g11[ix+i] * g0[iy+i] * g20[iz+i];
s[181] += g10[ix+i] * g1[iy+i] * g20[iz+i];
s[182] += g10[ix+i] * g0[iy+i] * g21[iz+i];
s[183] += g9[ix+i] * g2[iy+i] * g20[iz+i];
s[184] += g8[ix+i] * g3[iy+i] * g20[iz+i];
s[185] += g8[ix+i] * g2[iy+i] * g21[iz+i];
s[186] += g9[ix+i] * g0[iy+i] * g22[iz+i];
s[187] += g8[ix+i] * g1[iy+i] * g22[iz+i];
s[188] += g8[ix+i] * g0[iy+i] * g23[iz+i];
s[189] += g7[ix+i] * g8[iy+i] * g16[iz+i];
s[190] += g6[ix+i] * g9[iy+i] * g16[iz+i];
s[191] += g6[ix+i] * g8[iy+i] * g17[iz+i];
s[192] += g5[ix+i] * g10[iy+i] * g16[iz+i];
s[193] += g4[ix+i] * g11[iy+i] * g16[iz+i];
s[194] += g4[ix+i] * g10[iy+i] * g17[iz+i];
s[195] += g5[ix+i] * g8[iy+i] * g18[iz+i];
s[196] += g4[ix+i] * g9[iy+i] * g18[iz+i];
s[197] += g4[ix+i] * g8[iy+i] * g19[iz+i];
s[198] += g3[ix+i] * g12[iy+i] * g16[iz+i];
s[199] += g2[ix+i] * g13[iy+i] * g16[iz+i];
s[200] += g2[ix+i] * g12[iy+i] * g17[iz+i];
s[201] += g1[ix+i] * g14[iy+i] * g16[iz+i];
s[202] += g0[ix+i] * g15[iy+i] * g16[iz+i];
s[203] += g0[ix+i] * g14[iy+i] * g17[iz+i];
s[204] += g1[ix+i] * g12[iy+i] * g18[iz+i];
s[205] += g0[ix+i] * g13[iy+i] * g18[iz+i];
s[206] += g0[ix+i] * g12[iy+i] * g19[iz+i];
s[207] += g3[ix+i] * g8[iy+i] * g20[iz+i];
s[208] += g2[ix+i] * g9[iy+i] * g20[iz+i];
s[209] += g2[ix+i] * g8[iy+i] * g21[iz+i];
s[210] += g1[ix+i] * g10[iy+i] * g20[iz+i];
s[211] += g0[ix+i] * g11[iy+i] * g20[iz+i];
s[212] += g0[ix+i] * g10[iy+i] * g21[iz+i];
s[213] += g1[ix+i] * g8[iy+i] * g22[iz+i];
s[214] += g0[ix+i] * g9[iy+i] * g22[iz+i];
s[215] += g0[ix+i] * g8[iy+i] * g23[iz+i];
s[216] += g7[ix+i] * g0[iy+i] * g24[iz+i];
s[217] += g6[ix+i] * g1[iy+i] * g24[iz+i];
s[218] += g6[ix+i] * g0[iy+i] * g25[iz+i];
s[219] += g5[ix+i] * g2[iy+i] * g24[iz+i];
s[220] += g4[ix+i] * g3[iy+i] * g24[iz+i];
s[221] += g4[ix+i] * g2[iy+i] * g25[iz+i];
s[222] += g5[ix+i] * g0[iy+i] * g26[iz+i];
s[223] += g4[ix+i] * g1[iy+i] * g26[iz+i];
s[224] += g4[ix+i] * g0[iy+i] * g27[iz+i];
s[225] += g3[ix+i] * g4[iy+i] * g24[iz+i];
s[226] += g2[ix+i] * g5[iy+i] * g24[iz+i];
s[227] += g2[ix+i] * g4[iy+i] * g25[iz+i];
s[228] += g1[ix+i] * g6[iy+i] * g24[iz+i];
s[229] += g0[ix+i] * g7[iy+i] * g24[iz+i];
s[230] += g0[ix+i] * g6[iy+i] * g25[iz+i];
s[231] += g1[ix+i] * g4[iy+i] * g26[iz+i];
s[232] += g0[ix+i] * g5[iy+i] * g26[iz+i];
s[233] += g0[ix+i] * g4[iy+i] * g27[iz+i];
s[234] += g3[ix+i] * g0[iy+i] * g28[iz+i];
s[235] += g2[ix+i] * g1[iy+i] * g28[iz+i];
s[236] += g2[ix+i] * g0[iy+i] * g29[iz+i];
s[237] += g1[ix+i] * g2[iy+i] * g28[iz+i];
s[238] += g0[ix+i] * g3[iy+i] * g28[iz+i];
s[239] += g0[ix+i] * g2[iy+i] * g29[iz+i];
s[240] += g1[ix+i] * g0[iy+i] * g30[iz+i];
s[241] += g0[ix+i] * g1[iy+i] * g30[iz+i];
s[242] += g0[ix+i] * g0[iy+i] * g31[iz+i];
}
if (gout_empty) {
gout[0] = + s[104] + (-1*s[176]) + (-1*s[106]) + s[178];
gout[1] = + s[167] + (-1*s[23]) + (-1*s[169]) + s[25];
gout[2] = + s[14] + (-1*s[86]) + (-1*s[16]) + s[88];
gout[3] = + s[5] + s[95] + s[185] + (-1*s[7]) + (-1*s[97]) + (-1*s[187]);
gout[4] = + s[105] + (-1*s[177]) + (-1*s[101]) + s[173];
gout[5] = + s[168] + (-1*s[24]) + (-1*s[164]) + s[20];
gout[6] = + s[15] + (-1*s[87]) + (-1*s[11]) + s[83];
gout[7] = + s[6] + s[96] + s[186] + (-1*s[2]) + (-1*s[92]) + (-1*s[182]);
gout[8] = + s[100] + (-1*s[172]) + (-1*s[102]) + s[174];
gout[9] = + s[163] + (-1*s[19]) + (-1*s[165]) + s[21];
gout[10] = + s[10] + (-1*s[82]) + (-1*s[12]) + s[84];
gout[11] = + s[1] + s[91] + s[181] + (-1*s[3]) + (-1*s[93]) + (-1*s[183]);
gout[12] = + s[99] + (-1*s[171]) + s[103] + (-1*s[175]) + s[107] + (-1*s[179]);
gout[13] = + s[162] + (-1*s[18]) + s[166] + (-1*s[22]) + s[170] + (-1*s[26]);
gout[14] = + s[9] + (-1*s[81]) + s[13] + (-1*s[85]) + s[17] + (-1*s[89]);
gout[15] = + s[0] + s[90] + s[180] + s[4] + s[94] + s[184] + s[8] + s[98] + s[188];
gout[16] = + s[131] + (-1*s[203]) + (-1*s[133]) + s[205];
gout[17] = + s[194] + (-1*s[50]) + (-1*s[196]) + s[52];
gout[18] = + s[41] + (-1*s[113]) + (-1*s[43]) + s[115];
gout[19] = + s[32] + s[122] + s[212] + (-1*s[34]) + (-1*s[124]) + (-1*s[214]);
gout[20] = + s[132] + (-1*s[204]) + (-1*s[128]) + s[200];
gout[21] = + s[195] + (-1*s[51]) + (-1*s[191]) + s[47];
gout[22] = + s[42] + (-1*s[114]) + (-1*s[38]) + s[110];
gout[23] = + s[33] + s[123] + s[213] + (-1*s[29]) + (-1*s[119]) + (-1*s[209]);
gout[24] = + s[127] + (-1*s[199]) + (-1*s[129]) + s[201];
gout[25] = + s[190] + (-1*s[46]) + (-1*s[192]) + s[48];
gout[26] = + s[37] + (-1*s[109]) + (-1*s[39]) + s[111];
gout[27] = + s[28] + s[118] + s[208] + (-1*s[30]) + (-1*s[120]) + (-1*s[210]);
gout[28] = + s[126] + (-1*s[198]) + s[130] + (-1*s[202]) + s[134] + (-1*s[206]);
gout[29] = + s[189] + (-1*s[45]) + s[193] + (-1*s[49]) + s[197] + (-1*s[53]);
gout[30] = + s[36] + (-1*s[108]) + s[40] + (-1*s[112]) + s[44] + (-1*s[116]);
gout[31] = + s[27] + s[117] + s[207] + s[31] + s[121] + s[211] + s[35] + s[125] + s[215];
gout[32] = + s[158] + (-1*s[230]) + (-1*s[160]) + s[232];
gout[33] = + s[221] + (-1*s[77]) + (-1*s[223]) + s[79];
gout[34] = + s[68] + (-1*s[140]) + (-1*s[70]) + s[142];
gout[35] = + s[59] + s[149] + s[239] + (-1*s[61]) + (-1*s[151]) + (-1*s[241]);
gout[36] = + s[159] + (-1*s[231]) + (-1*s[155]) + s[227];
gout[37] = + s[222] + (-1*s[78]) + (-1*s[218]) + s[74];
gout[38] = + s[69] + (-1*s[141]) + (-1*s[65]) + s[137];
gout[39] = + s[60] + s[150] + s[240] + (-1*s[56]) + (-1*s[146]) + (-1*s[236]);
gout[40] = + s[154] + (-1*s[226]) + (-1*s[156]) + s[228];
gout[41] = + s[217] + (-1*s[73]) + (-1*s[219]) + s[75];
gout[42] = + s[64] + (-1*s[136]) + (-1*s[66]) + s[138];
gout[43] = + s[55] + s[145] + s[235] + (-1*s[57]) + (-1*s[147]) + (-1*s[237]);
gout[44] = + s[153] + (-1*s[225]) + s[157] + (-1*s[229]) + s[161] + (-1*s[233]);
gout[45] = + s[216] + (-1*s[72]) + s[220] + (-1*s[76]) + s[224] + (-1*s[80]);
gout[46] = + s[63] + (-1*s[135]) + s[67] + (-1*s[139]) + s[71] + (-1*s[143]);
gout[47] = + s[54] + s[144] + s[234] + s[58] + s[148] + s[238] + s[62] + s[152] + s[242];
gout += 48;
} else {
gout[0] += + s[104] + (-1*s[176]) + (-1*s[106]) + s[178];
gout[1] += + s[167] + (-1*s[23]) + (-1*s[169]) + s[25];
gout[2] += + s[14] + (-1*s[86]) + (-1*s[16]) + s[88];
gout[3] += + s[5] + s[95] + s[185] + (-1*s[7]) + (-1*s[97]) + (-1*s[187]);
gout[4] += + s[105] + (-1*s[177]) + (-1*s[101]) + s[173];
gout[5] += + s[168] + (-1*s[24]) + (-1*s[164]) + s[20];
gout[6] += + s[15] + (-1*s[87]) + (-1*s[11]) + s[83];
gout[7] += + s[6] + s[96] + s[186] + (-1*s[2]) + (-1*s[92]) + (-1*s[182]);
gout[8] += + s[100] + (-1*s[172]) + (-1*s[102]) + s[174];
gout[9] += + s[163] + (-1*s[19]) + (-1*s[165]) + s[21];
gout[10] += + s[10] + (-1*s[82]) + (-1*s[12]) + s[84];
gout[11] += + s[1] + s[91] + s[181] + (-1*s[3]) + (-1*s[93]) + (-1*s[183]);
gout[12] += + s[99] + (-1*s[171]) + s[103] + (-1*s[175]) + s[107] + (-1*s[179]);
gout[13] += + s[162] + (-1*s[18]) + s[166] + (-1*s[22]) + s[170] + (-1*s[26]);
gout[14] += + s[9] + (-1*s[81]) + s[13] + (-1*s[85]) + s[17] + (-1*s[89]);
gout[15] += + s[0] + s[90] + s[180] + s[4] + s[94] + s[184] + s[8] + s[98] + s[188];
gout[16] += + s[131] + (-1*s[203]) + (-1*s[133]) + s[205];
gout[17] += + s[194] + (-1*s[50]) + (-1*s[196]) + s[52];
gout[18] += + s[41] + (-1*s[113]) + (-1*s[43]) + s[115];
gout[19] += + s[32] + s[122] + s[212] + (-1*s[34]) + (-1*s[124]) + (-1*s[214]);
gout[20] += + s[132] + (-1*s[204]) + (-1*s[128]) + s[200];
gout[21] += + s[195] + (-1*s[51]) + (-1*s[191]) + s[47];
gout[22] += + s[42] + (-1*s[114]) + (-1*s[38]) + s[110];
gout[23] += + s[33] + s[123] + s[213] + (-1*s[29]) + (-1*s[119]) + (-1*s[209]);
gout[24] += + s[127] + (-1*s[199]) + (-1*s[129]) + s[201];
gout[25] += + s[190] + (-1*s[46]) + (-1*s[192]) + s[48];
gout[26] += + s[37] + (-1*s[109]) + (-1*s[39]) + s[111];
gout[27] += + s[28] + s[118] + s[208] + (-1*s[30]) + (-1*s[120]) + (-1*s[210]);
gout[28] += + s[126] + (-1*s[198]) + s[130] + (-1*s[202]) + s[134] + (-1*s[206]);
gout[29] += + s[189] + (-1*s[45]) + s[193] + (-1*s[49]) + s[197] + (-1*s[53]);
gout[30] += + s[36] + (-1*s[108]) + s[40] + (-1*s[112]) + s[44] + (-1*s[116]);
gout[31] += + s[27] + s[117] + s[207] + s[31] + s[121] + s[211] + s[35] + s[125] + s[215];
gout[32] += + s[158] + (-1*s[230]) + (-1*s[160]) + s[232];
gout[33] += + s[221] + (-1*s[77]) + (-1*s[223]) + s[79];
gout[34] += + s[68] + (-1*s[140]) + (-1*s[70]) + s[142];
gout[35] += + s[59] + s[149] + s[239] + (-1*s[61]) + (-1*s[151]) + (-1*s[241]);
gout[36] += + s[159] + (-1*s[231]) + (-1*s[155]) + s[227];
gout[37] += + s[222] + (-1*s[78]) + (-1*s[218]) + s[74];
gout[38] += + s[69] + (-1*s[141]) + (-1*s[65]) + s[137];
gout[39] += + s[60] + s[150] + s[240] + (-1*s[56]) + (-1*s[146]) + (-1*s[236]);
gout[40] += + s[154] + (-1*s[226]) + (-1*s[156]) + s[228];
gout[41] += + s[217] + (-1*s[73]) + (-1*s[219]) + s[75];
gout[42] += + s[64] + (-1*s[136]) + (-1*s[66]) + s[138];
gout[43] += + s[55] + s[145] + s[235] + (-1*s[57]) + (-1*s[147]) + (-1*s[237]);
gout[44] += + s[153] + (-1*s[225]) + s[157] + (-1*s[229]) + s[161] + (-1*s[233]);
gout[45] += + s[216] + (-1*s[72]) + s[220] + (-1*s[76]) + s[224] + (-1*s[80]);
gout[46] += + s[63] + (-1*s[135]) + s[67] + (-1*s[139]) + s[71] + (-1*s[143]);
gout[47] += + s[54] + s[144] + s[234] + s[58] + s[148] + s[238] + s[62] + s[152] + s[242];
gout += 48;
}}}
void cint2e_ipspsp1spsp2_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ipspsp1spsp2(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ipspsp1spsp2;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_si_2e1, &c2s_si_2e2);
}
OPTIMIZER2F_(cint2e_ipspsp1spsp2_optimizer);
C2Fo_(cint2e_ipspsp1spsp2)
/* <k NABLA SIGMA DOT R i|R12 |SIGMA DOT R j l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT R i SIGMA DOT R j|R12 |k l) */
static void CINTgout2e_cint2e_ipsrsr1(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double s[27];
G2E_R_J(g1, g0, i_l+2, j_l+0, k_l, l_l);
G2E_D_I(g2, g0, i_l+1, j_l, k_l, l_l);
G2E_D_I(g3, g1, i_l+1, j_l, k_l, l_l);
G2E_R_I(g4, g0, i_l+0, j_l, k_l, l_l);
G2E_R_I(g5, g1, i_l+0, j_l, k_l, l_l);
G2E_R_I(g6, g2, i_l+0, j_l, k_l, l_l);
G2E_R_I(g7, g3, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(27, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
if (gout_empty) {
gout[0] = + s[11] + (-1*s[19]);
gout[1] = + s[18] + (-1*s[2]);
gout[2] = + s[1] + (-1*s[9]);
gout[3] = + s[0] + s[10] + s[20];
gout[4] = + s[14] + (-1*s[22]);
gout[5] = + s[21] + (-1*s[5]);
gout[6] = + s[4] + (-1*s[12]);
gout[7] = + s[3] + s[13] + s[23];
gout[8] = + s[17] + (-1*s[25]);
gout[9] = + s[24] + (-1*s[8]);
gout[10] = + s[7] + (-1*s[15]);
gout[11] = + s[6] + s[16] + s[26];
gout += 12;
} else {
gout[0] += + s[11] + (-1*s[19]);
gout[1] += + s[18] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[9]);
gout[3] += + s[0] + s[10] + s[20];
gout[4] += + s[14] + (-1*s[22]);
gout[5] += + s[21] + (-1*s[5]);
gout[6] += + s[4] + (-1*s[12]);
gout[7] += + s[3] + s[13] + s[23];
gout[8] += + s[17] + (-1*s[25]);
gout[9] += + s[24] + (-1*s[8]);
gout[10] += + s[7] + (-1*s[15]);
gout[11] += + s[6] + s[16] + s[26];
gout += 12;
}}}
void cint2e_ipsrsr1_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ipsrsr1(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ipsrsr1;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_si_2e1, &c2s_sf_2e2);
}
OPTIMIZER2F_(cint2e_ipsrsr1_optimizer);
C2Fo_(cint2e_ipsrsr1)
/* <SIGMA DOT R k NABLA i|R12 |j SIGMA DOT R l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA i j|R12 |SIGMA DOT R k SIGMA DOT R l) */
static void CINTgout2e_cint2e_ip1srsr2(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double s[27];
G2E_R_L(g1, g0, i_l+1, j_l+0, k_l+1, l_l+0);
G2E_R_K(g2, g0, i_l+1, j_l+0, k_l+0, l_l);
G2E_R_K(g3, g1, i_l+1, j_l+0, k_l+0, l_l);
G2E_D_I(g4, g0, i_l+0, j_l, k_l, l_l);
G2E_D_I(g5, g1, i_l+0, j_l, k_l, l_l);
G2E_D_I(g6, g2, i_l+0, j_l, k_l, l_l);
G2E_D_I(g7, g3, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(27, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
if (gout_empty) {
gout[0] = + s[5] + (-1*s[7]);
gout[1] = + s[6] + (-1*s[2]);
gout[2] = + s[1] + (-1*s[3]);
gout[3] = + s[0] + s[4] + s[8];
gout[4] = + s[14] + (-1*s[16]);
gout[5] = + s[15] + (-1*s[11]);
gout[6] = + s[10] + (-1*s[12]);
gout[7] = + s[9] + s[13] + s[17];
gout[8] = + s[23] + (-1*s[25]);
gout[9] = + s[24] + (-1*s[20]);
gout[10] = + s[19] + (-1*s[21]);
gout[11] = + s[18] + s[22] + s[26];
gout += 12;
} else {
gout[0] += + s[5] + (-1*s[7]);
gout[1] += + s[6] + (-1*s[2]);
gout[2] += + s[1] + (-1*s[3]);
gout[3] += + s[0] + s[4] + s[8];
gout[4] += + s[14] + (-1*s[16]);
gout[5] += + s[15] + (-1*s[11]);
gout[6] += + s[10] + (-1*s[12]);
gout[7] += + s[9] + s[13] + s[17];
gout[8] += + s[23] + (-1*s[25]);
gout[9] += + s[24] + (-1*s[20]);
gout[10] += + s[19] + (-1*s[21]);
gout[11] += + s[18] + s[22] + s[26];
gout += 12;
}}}
void cint2e_ip1srsr2_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ip1srsr2(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ip1srsr2;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_sf_2e1, &c2s_si_2e2);
}
OPTIMIZER2F_(cint2e_ip1srsr2_optimizer);
C2Fo_(cint2e_ip1srsr2)
/* <SIGMA DOT R k NABLA SIGMA DOT R i|R12 |SIGMA DOT R j SIGMA DOT R l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT R i SIGMA DOT R j|R12 |SIGMA DOT R k SIGMA DOT R l) */
static void CINTgout2e_cint2e_ipsrsr1srsr2(double *g,
double *gout, const FINT *idx, const CINTEnvVars *envs, FINT gout_empty) {
const double *env = envs->env;
const FINT nf = envs->nf;
const FINT i_l = envs->i_l;
const FINT j_l = envs->j_l;
const FINT k_l = envs->k_l;
const FINT l_l = envs->l_l;
const double *ri = envs->ri;
const double *rj = envs->rj;
const double *rk = envs->rk;
const double *rl = envs->rl;
FINT ix, iy, iz, i, n;
double *g0 = g;
double *g1 = g0 + envs->g_size * 3;
double *g2 = g1 + envs->g_size * 3;
double *g3 = g2 + envs->g_size * 3;
double *g4 = g3 + envs->g_size * 3;
double *g5 = g4 + envs->g_size * 3;
double *g6 = g5 + envs->g_size * 3;
double *g7 = g6 + envs->g_size * 3;
double *g8 = g7 + envs->g_size * 3;
double *g9 = g8 + envs->g_size * 3;
double *g10 = g9 + envs->g_size * 3;
double *g11 = g10 + envs->g_size * 3;
double *g12 = g11 + envs->g_size * 3;
double *g13 = g12 + envs->g_size * 3;
double *g14 = g13 + envs->g_size * 3;
double *g15 = g14 + envs->g_size * 3;
double *g16 = g15 + envs->g_size * 3;
double *g17 = g16 + envs->g_size * 3;
double *g18 = g17 + envs->g_size * 3;
double *g19 = g18 + envs->g_size * 3;
double *g20 = g19 + envs->g_size * 3;
double *g21 = g20 + envs->g_size * 3;
double *g22 = g21 + envs->g_size * 3;
double *g23 = g22 + envs->g_size * 3;
double *g24 = g23 + envs->g_size * 3;
double *g25 = g24 + envs->g_size * 3;
double *g26 = g25 + envs->g_size * 3;
double *g27 = g26 + envs->g_size * 3;
double *g28 = g27 + envs->g_size * 3;
double *g29 = g28 + envs->g_size * 3;
double *g30 = g29 + envs->g_size * 3;
double *g31 = g30 + envs->g_size * 3;
double *g32 = g31 + envs->g_size * 3;
double s[243];
G2E_R_L(g1, g0, i_l+2, j_l+1, k_l+1, l_l+0);
G2E_R_K(g2, g0, i_l+2, j_l+1, k_l+0, l_l);
G2E_R_K(g3, g1, i_l+2, j_l+1, k_l+0, l_l);
G2E_R_J(g4, g0, i_l+2, j_l+0, k_l, l_l);
G2E_R_J(g5, g1, i_l+2, j_l+0, k_l, l_l);
G2E_R_J(g6, g2, i_l+2, j_l+0, k_l, l_l);
G2E_R_J(g7, g3, i_l+2, j_l+0, k_l, l_l);
G2E_D_I(g8, g0, i_l+1, j_l, k_l, l_l);
G2E_D_I(g9, g1, i_l+1, j_l, k_l, l_l);
G2E_D_I(g10, g2, i_l+1, j_l, k_l, l_l);
G2E_D_I(g11, g3, i_l+1, j_l, k_l, l_l);
G2E_D_I(g12, g4, i_l+1, j_l, k_l, l_l);
G2E_D_I(g13, g5, i_l+1, j_l, k_l, l_l);
G2E_D_I(g14, g6, i_l+1, j_l, k_l, l_l);
G2E_D_I(g15, g7, i_l+1, j_l, k_l, l_l);
G2E_R_I(g16, g0, i_l+0, j_l, k_l, l_l);
G2E_R_I(g17, g1, i_l+0, j_l, k_l, l_l);
G2E_R_I(g18, g2, i_l+0, j_l, k_l, l_l);
G2E_R_I(g19, g3, i_l+0, j_l, k_l, l_l);
G2E_R_I(g20, g4, i_l+0, j_l, k_l, l_l);
G2E_R_I(g21, g5, i_l+0, j_l, k_l, l_l);
G2E_R_I(g22, g6, i_l+0, j_l, k_l, l_l);
G2E_R_I(g23, g7, i_l+0, j_l, k_l, l_l);
G2E_R_I(g24, g8, i_l+0, j_l, k_l, l_l);
G2E_R_I(g25, g9, i_l+0, j_l, k_l, l_l);
G2E_R_I(g26, g10, i_l+0, j_l, k_l, l_l);
G2E_R_I(g27, g11, i_l+0, j_l, k_l, l_l);
G2E_R_I(g28, g12, i_l+0, j_l, k_l, l_l);
G2E_R_I(g29, g13, i_l+0, j_l, k_l, l_l);
G2E_R_I(g30, g14, i_l+0, j_l, k_l, l_l);
G2E_R_I(g31, g15, i_l+0, j_l, k_l, l_l);
__m128d r0, r1, r2, r3;
for (n = 0; n < nf; n++, idx+=3) {
ix = idx[0];
iy = idx[1];
iz = idx[2];
CINTdset0(243, s);
for (i = 0; i < envs->nrys_roots; i++) {
s[0] += g31[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g30[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g30[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g29[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g28[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g28[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g29[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g28[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g28[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g27[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g26[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g26[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g25[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g24[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g24[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g25[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g24[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g24[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g27[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g26[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g26[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g25[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g24[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g24[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g25[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g24[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g24[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g23[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g22[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g22[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g21[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g20[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g20[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g21[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g20[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g20[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g19[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g18[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g18[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g17[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g16[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g16[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g17[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g16[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g16[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g19[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g18[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g18[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g17[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g16[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g16[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g17[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g16[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g16[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g23[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g22[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g22[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g21[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g20[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g20[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g21[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g20[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g20[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g19[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g18[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g18[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g17[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g16[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g16[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g17[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g16[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g16[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g19[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g18[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g18[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g17[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g16[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g16[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g17[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g16[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g16[ix+i] * g0[iy+i] * g15[iz+i];
s[81] += g15[ix+i] * g16[iy+i] * g0[iz+i];
s[82] += g14[ix+i] * g17[iy+i] * g0[iz+i];
s[83] += g14[ix+i] * g16[iy+i] * g1[iz+i];
s[84] += g13[ix+i] * g18[iy+i] * g0[iz+i];
s[85] += g12[ix+i] * g19[iy+i] * g0[iz+i];
s[86] += g12[ix+i] * g18[iy+i] * g1[iz+i];
s[87] += g13[ix+i] * g16[iy+i] * g2[iz+i];
s[88] += g12[ix+i] * g17[iy+i] * g2[iz+i];
s[89] += g12[ix+i] * g16[iy+i] * g3[iz+i];
s[90] += g11[ix+i] * g20[iy+i] * g0[iz+i];
s[91] += g10[ix+i] * g21[iy+i] * g0[iz+i];
s[92] += g10[ix+i] * g20[iy+i] * g1[iz+i];
s[93] += g9[ix+i] * g22[iy+i] * g0[iz+i];
s[94] += g8[ix+i] * g23[iy+i] * g0[iz+i];
s[95] += g8[ix+i] * g22[iy+i] * g1[iz+i];
s[96] += g9[ix+i] * g20[iy+i] * g2[iz+i];
s[97] += g8[ix+i] * g21[iy+i] * g2[iz+i];
s[98] += g8[ix+i] * g20[iy+i] * g3[iz+i];
s[99] += g11[ix+i] * g16[iy+i] * g4[iz+i];
s[100] += g10[ix+i] * g17[iy+i] * g4[iz+i];
s[101] += g10[ix+i] * g16[iy+i] * g5[iz+i];
s[102] += g9[ix+i] * g18[iy+i] * g4[iz+i];
s[103] += g8[ix+i] * g19[iy+i] * g4[iz+i];
s[104] += g8[ix+i] * g18[iy+i] * g5[iz+i];
s[105] += g9[ix+i] * g16[iy+i] * g6[iz+i];
s[106] += g8[ix+i] * g17[iy+i] * g6[iz+i];
s[107] += g8[ix+i] * g16[iy+i] * g7[iz+i];
s[108] += g7[ix+i] * g24[iy+i] * g0[iz+i];
s[109] += g6[ix+i] * g25[iy+i] * g0[iz+i];
s[110] += g6[ix+i] * g24[iy+i] * g1[iz+i];
s[111] += g5[ix+i] * g26[iy+i] * g0[iz+i];
s[112] += g4[ix+i] * g27[iy+i] * g0[iz+i];
s[113] += g4[ix+i] * g26[iy+i] * g1[iz+i];
s[114] += g5[ix+i] * g24[iy+i] * g2[iz+i];
s[115] += g4[ix+i] * g25[iy+i] * g2[iz+i];
s[116] += g4[ix+i] * g24[iy+i] * g3[iz+i];
s[117] += g3[ix+i] * g28[iy+i] * g0[iz+i];
s[118] += g2[ix+i] * g29[iy+i] * g0[iz+i];
s[119] += g2[ix+i] * g28[iy+i] * g1[iz+i];
s[120] += g1[ix+i] * g30[iy+i] * g0[iz+i];
s[121] += g0[ix+i] * g31[iy+i] * g0[iz+i];
s[122] += g0[ix+i] * g30[iy+i] * g1[iz+i];
s[123] += g1[ix+i] * g28[iy+i] * g2[iz+i];
s[124] += g0[ix+i] * g29[iy+i] * g2[iz+i];
s[125] += g0[ix+i] * g28[iy+i] * g3[iz+i];
s[126] += g3[ix+i] * g24[iy+i] * g4[iz+i];
s[127] += g2[ix+i] * g25[iy+i] * g4[iz+i];
s[128] += g2[ix+i] * g24[iy+i] * g5[iz+i];
s[129] += g1[ix+i] * g26[iy+i] * g4[iz+i];
s[130] += g0[ix+i] * g27[iy+i] * g4[iz+i];
s[131] += g0[ix+i] * g26[iy+i] * g5[iz+i];
s[132] += g1[ix+i] * g24[iy+i] * g6[iz+i];
s[133] += g0[ix+i] * g25[iy+i] * g6[iz+i];
s[134] += g0[ix+i] * g24[iy+i] * g7[iz+i];
s[135] += g7[ix+i] * g16[iy+i] * g8[iz+i];
s[136] += g6[ix+i] * g17[iy+i] * g8[iz+i];
s[137] += g6[ix+i] * g16[iy+i] * g9[iz+i];
s[138] += g5[ix+i] * g18[iy+i] * g8[iz+i];
s[139] += g4[ix+i] * g19[iy+i] * g8[iz+i];
s[140] += g4[ix+i] * g18[iy+i] * g9[iz+i];
s[141] += g5[ix+i] * g16[iy+i] * g10[iz+i];
s[142] += g4[ix+i] * g17[iy+i] * g10[iz+i];
s[143] += g4[ix+i] * g16[iy+i] * g11[iz+i];
s[144] += g3[ix+i] * g20[iy+i] * g8[iz+i];
s[145] += g2[ix+i] * g21[iy+i] * g8[iz+i];
s[146] += g2[ix+i] * g20[iy+i] * g9[iz+i];
s[147] += g1[ix+i] * g22[iy+i] * g8[iz+i];
s[148] += g0[ix+i] * g23[iy+i] * g8[iz+i];
s[149] += g0[ix+i] * g22[iy+i] * g9[iz+i];
s[150] += g1[ix+i] * g20[iy+i] * g10[iz+i];
s[151] += g0[ix+i] * g21[iy+i] * g10[iz+i];
s[152] += g0[ix+i] * g20[iy+i] * g11[iz+i];
s[153] += g3[ix+i] * g16[iy+i] * g12[iz+i];
s[154] += g2[ix+i] * g17[iy+i] * g12[iz+i];
s[155] += g2[ix+i] * g16[iy+i] * g13[iz+i];
s[156] += g1[ix+i] * g18[iy+i] * g12[iz+i];
s[157] += g0[ix+i] * g19[iy+i] * g12[iz+i];
s[158] += g0[ix+i] * g18[iy+i] * g13[iz+i];
s[159] += g1[ix+i] * g16[iy+i] * g14[iz+i];
s[160] += g0[ix+i] * g17[iy+i] * g14[iz+i];
s[161] += g0[ix+i] * g16[iy+i] * g15[iz+i];
s[162] += g15[ix+i] * g0[iy+i] * g16[iz+i];
s[163] += g14[ix+i] * g1[iy+i] * g16[iz+i];
s[164] += g14[ix+i] * g0[iy+i] * g17[iz+i];
s[165] += g13[ix+i] * g2[iy+i] * g16[iz+i];
s[166] += g12[ix+i] * g3[iy+i] * g16[iz+i];
s[167] += g12[ix+i] * g2[iy+i] * g17[iz+i];
s[168] += g13[ix+i] * g0[iy+i] * g18[iz+i];
s[169] += g12[ix+i] * g1[iy+i] * g18[iz+i];
s[170] += g12[ix+i] * g0[iy+i] * g19[iz+i];
s[171] += g11[ix+i] * g4[iy+i] * g16[iz+i];
s[172] += g10[ix+i] * g5[iy+i] * g16[iz+i];
s[173] += g10[ix+i] * g4[iy+i] * g17[iz+i];
s[174] += g9[ix+i] * g6[iy+i] * g16[iz+i];
s[175] += g8[ix+i] * g7[iy+i] * g16[iz+i];
s[176] += g8[ix+i] * g6[iy+i] * g17[iz+i];
s[177] += g9[ix+i] * g4[iy+i] * g18[iz+i];
s[178] += g8[ix+i] * g5[iy+i] * g18[iz+i];
s[179] += g8[ix+i] * g4[iy+i] * g19[iz+i];
s[180] += g11[ix+i] * g0[iy+i] * g20[iz+i];
s[181] += g10[ix+i] * g1[iy+i] * g20[iz+i];
s[182] += g10[ix+i] * g0[iy+i] * g21[iz+i];
s[183] += g9[ix+i] * g2[iy+i] * g20[iz+i];
s[184] += g8[ix+i] * g3[iy+i] * g20[iz+i];
s[185] += g8[ix+i] * g2[iy+i] * g21[iz+i];
s[186] += g9[ix+i] * g0[iy+i] * g22[iz+i];
s[187] += g8[ix+i] * g1[iy+i] * g22[iz+i];
s[188] += g8[ix+i] * g0[iy+i] * g23[iz+i];
s[189] += g7[ix+i] * g8[iy+i] * g16[iz+i];
s[190] += g6[ix+i] * g9[iy+i] * g16[iz+i];
s[191] += g6[ix+i] * g8[iy+i] * g17[iz+i];
s[192] += g5[ix+i] * g10[iy+i] * g16[iz+i];
s[193] += g4[ix+i] * g11[iy+i] * g16[iz+i];
s[194] += g4[ix+i] * g10[iy+i] * g17[iz+i];
s[195] += g5[ix+i] * g8[iy+i] * g18[iz+i];
s[196] += g4[ix+i] * g9[iy+i] * g18[iz+i];
s[197] += g4[ix+i] * g8[iy+i] * g19[iz+i];
s[198] += g3[ix+i] * g12[iy+i] * g16[iz+i];
s[199] += g2[ix+i] * g13[iy+i] * g16[iz+i];
s[200] += g2[ix+i] * g12[iy+i] * g17[iz+i];
s[201] += g1[ix+i] * g14[iy+i] * g16[iz+i];
s[202] += g0[ix+i] * g15[iy+i] * g16[iz+i];
s[203] += g0[ix+i] * g14[iy+i] * g17[iz+i];
s[204] += g1[ix+i] * g12[iy+i] * g18[iz+i];
s[205] += g0[ix+i] * g13[iy+i] * g18[iz+i];
s[206] += g0[ix+i] * g12[iy+i] * g19[iz+i];
s[207] += g3[ix+i] * g8[iy+i] * g20[iz+i];
s[208] += g2[ix+i] * g9[iy+i] * g20[iz+i];
s[209] += g2[ix+i] * g8[iy+i] * g21[iz+i];
s[210] += g1[ix+i] * g10[iy+i] * g20[iz+i];
s[211] += g0[ix+i] * g11[iy+i] * g20[iz+i];
s[212] += g0[ix+i] * g10[iy+i] * g21[iz+i];
s[213] += g1[ix+i] * g8[iy+i] * g22[iz+i];
s[214] += g0[ix+i] * g9[iy+i] * g22[iz+i];
s[215] += g0[ix+i] * g8[iy+i] * g23[iz+i];
s[216] += g7[ix+i] * g0[iy+i] * g24[iz+i];
s[217] += g6[ix+i] * g1[iy+i] * g24[iz+i];
s[218] += g6[ix+i] * g0[iy+i] * g25[iz+i];
s[219] += g5[ix+i] * g2[iy+i] * g24[iz+i];
s[220] += g4[ix+i] * g3[iy+i] * g24[iz+i];
s[221] += g4[ix+i] * g2[iy+i] * g25[iz+i];
s[222] += g5[ix+i] * g0[iy+i] * g26[iz+i];
s[223] += g4[ix+i] * g1[iy+i] * g26[iz+i];
s[224] += g4[ix+i] * g0[iy+i] * g27[iz+i];
s[225] += g3[ix+i] * g4[iy+i] * g24[iz+i];
s[226] += g2[ix+i] * g5[iy+i] * g24[iz+i];
s[227] += g2[ix+i] * g4[iy+i] * g25[iz+i];
s[228] += g1[ix+i] * g6[iy+i] * g24[iz+i];
s[229] += g0[ix+i] * g7[iy+i] * g24[iz+i];
s[230] += g0[ix+i] * g6[iy+i] * g25[iz+i];
s[231] += g1[ix+i] * g4[iy+i] * g26[iz+i];
s[232] += g0[ix+i] * g5[iy+i] * g26[iz+i];
s[233] += g0[ix+i] * g4[iy+i] * g27[iz+i];
s[234] += g3[ix+i] * g0[iy+i] * g28[iz+i];
s[235] += g2[ix+i] * g1[iy+i] * g28[iz+i];
s[236] += g2[ix+i] * g0[iy+i] * g29[iz+i];
s[237] += g1[ix+i] * g2[iy+i] * g28[iz+i];
s[238] += g0[ix+i] * g3[iy+i] * g28[iz+i];
s[239] += g0[ix+i] * g2[iy+i] * g29[iz+i];
s[240] += g1[ix+i] * g0[iy+i] * g30[iz+i];
s[241] += g0[ix+i] * g1[iy+i] * g30[iz+i];
s[242] += g0[ix+i] * g0[iy+i] * g31[iz+i];
}
if (gout_empty) {
gout[0] = + s[104] + (-1*s[176]) + (-1*s[106]) + s[178];
gout[1] = + s[167] + (-1*s[23]) + (-1*s[169]) + s[25];
gout[2] = + s[14] + (-1*s[86]) + (-1*s[16]) + s[88];
gout[3] = + s[5] + s[95] + s[185] + (-1*s[7]) + (-1*s[97]) + (-1*s[187]);
gout[4] = + s[105] + (-1*s[177]) + (-1*s[101]) + s[173];
gout[5] = + s[168] + (-1*s[24]) + (-1*s[164]) + s[20];
gout[6] = + s[15] + (-1*s[87]) + (-1*s[11]) + s[83];
gout[7] = + s[6] + s[96] + s[186] + (-1*s[2]) + (-1*s[92]) + (-1*s[182]);
gout[8] = + s[100] + (-1*s[172]) + (-1*s[102]) + s[174];
gout[9] = + s[163] + (-1*s[19]) + (-1*s[165]) + s[21];
gout[10] = + s[10] + (-1*s[82]) + (-1*s[12]) + s[84];
gout[11] = + s[1] + s[91] + s[181] + (-1*s[3]) + (-1*s[93]) + (-1*s[183]);
gout[12] = + s[99] + (-1*s[171]) + s[103] + (-1*s[175]) + s[107] + (-1*s[179]);
gout[13] = + s[162] + (-1*s[18]) + s[166] + (-1*s[22]) + s[170] + (-1*s[26]);
gout[14] = + s[9] + (-1*s[81]) + s[13] + (-1*s[85]) + s[17] + (-1*s[89]);
gout[15] = + s[0] + s[90] + s[180] + s[4] + s[94] + s[184] + s[8] + s[98] + s[188];
gout[16] = + s[131] + (-1*s[203]) + (-1*s[133]) + s[205];
gout[17] = + s[194] + (-1*s[50]) + (-1*s[196]) + s[52];
gout[18] = + s[41] + (-1*s[113]) + (-1*s[43]) + s[115];
gout[19] = + s[32] + s[122] + s[212] + (-1*s[34]) + (-1*s[124]) + (-1*s[214]);
gout[20] = + s[132] + (-1*s[204]) + (-1*s[128]) + s[200];
gout[21] = + s[195] + (-1*s[51]) + (-1*s[191]) + s[47];
gout[22] = + s[42] + (-1*s[114]) + (-1*s[38]) + s[110];
gout[23] = + s[33] + s[123] + s[213] + (-1*s[29]) + (-1*s[119]) + (-1*s[209]);
gout[24] = + s[127] + (-1*s[199]) + (-1*s[129]) + s[201];
gout[25] = + s[190] + (-1*s[46]) + (-1*s[192]) + s[48];
gout[26] = + s[37] + (-1*s[109]) + (-1*s[39]) + s[111];
gout[27] = + s[28] + s[118] + s[208] + (-1*s[30]) + (-1*s[120]) + (-1*s[210]);
gout[28] = + s[126] + (-1*s[198]) + s[130] + (-1*s[202]) + s[134] + (-1*s[206]);
gout[29] = + s[189] + (-1*s[45]) + s[193] + (-1*s[49]) + s[197] + (-1*s[53]);
gout[30] = + s[36] + (-1*s[108]) + s[40] + (-1*s[112]) + s[44] + (-1*s[116]);
gout[31] = + s[27] + s[117] + s[207] + s[31] + s[121] + s[211] + s[35] + s[125] + s[215];
gout[32] = + s[158] + (-1*s[230]) + (-1*s[160]) + s[232];
gout[33] = + s[221] + (-1*s[77]) + (-1*s[223]) + s[79];
gout[34] = + s[68] + (-1*s[140]) + (-1*s[70]) + s[142];
gout[35] = + s[59] + s[149] + s[239] + (-1*s[61]) + (-1*s[151]) + (-1*s[241]);
gout[36] = + s[159] + (-1*s[231]) + (-1*s[155]) + s[227];
gout[37] = + s[222] + (-1*s[78]) + (-1*s[218]) + s[74];
gout[38] = + s[69] + (-1*s[141]) + (-1*s[65]) + s[137];
gout[39] = + s[60] + s[150] + s[240] + (-1*s[56]) + (-1*s[146]) + (-1*s[236]);
gout[40] = + s[154] + (-1*s[226]) + (-1*s[156]) + s[228];
gout[41] = + s[217] + (-1*s[73]) + (-1*s[219]) + s[75];
gout[42] = + s[64] + (-1*s[136]) + (-1*s[66]) + s[138];
gout[43] = + s[55] + s[145] + s[235] + (-1*s[57]) + (-1*s[147]) + (-1*s[237]);
gout[44] = + s[153] + (-1*s[225]) + s[157] + (-1*s[229]) + s[161] + (-1*s[233]);
gout[45] = + s[216] + (-1*s[72]) + s[220] + (-1*s[76]) + s[224] + (-1*s[80]);
gout[46] = + s[63] + (-1*s[135]) + s[67] + (-1*s[139]) + s[71] + (-1*s[143]);
gout[47] = + s[54] + s[144] + s[234] + s[58] + s[148] + s[238] + s[62] + s[152] + s[242];
gout += 48;
} else {
gout[0] += + s[104] + (-1*s[176]) + (-1*s[106]) + s[178];
gout[1] += + s[167] + (-1*s[23]) + (-1*s[169]) + s[25];
gout[2] += + s[14] + (-1*s[86]) + (-1*s[16]) + s[88];
gout[3] += + s[5] + s[95] + s[185] + (-1*s[7]) + (-1*s[97]) + (-1*s[187]);
gout[4] += + s[105] + (-1*s[177]) + (-1*s[101]) + s[173];
gout[5] += + s[168] + (-1*s[24]) + (-1*s[164]) + s[20];
gout[6] += + s[15] + (-1*s[87]) + (-1*s[11]) + s[83];
gout[7] += + s[6] + s[96] + s[186] + (-1*s[2]) + (-1*s[92]) + (-1*s[182]);
gout[8] += + s[100] + (-1*s[172]) + (-1*s[102]) + s[174];
gout[9] += + s[163] + (-1*s[19]) + (-1*s[165]) + s[21];
gout[10] += + s[10] + (-1*s[82]) + (-1*s[12]) + s[84];
gout[11] += + s[1] + s[91] + s[181] + (-1*s[3]) + (-1*s[93]) + (-1*s[183]);
gout[12] += + s[99] + (-1*s[171]) + s[103] + (-1*s[175]) + s[107] + (-1*s[179]);
gout[13] += + s[162] + (-1*s[18]) + s[166] + (-1*s[22]) + s[170] + (-1*s[26]);
gout[14] += + s[9] + (-1*s[81]) + s[13] + (-1*s[85]) + s[17] + (-1*s[89]);
gout[15] += + s[0] + s[90] + s[180] + s[4] + s[94] + s[184] + s[8] + s[98] + s[188];
gout[16] += + s[131] + (-1*s[203]) + (-1*s[133]) + s[205];
gout[17] += + s[194] + (-1*s[50]) + (-1*s[196]) + s[52];
gout[18] += + s[41] + (-1*s[113]) + (-1*s[43]) + s[115];
gout[19] += + s[32] + s[122] + s[212] + (-1*s[34]) + (-1*s[124]) + (-1*s[214]);
gout[20] += + s[132] + (-1*s[204]) + (-1*s[128]) + s[200];
gout[21] += + s[195] + (-1*s[51]) + (-1*s[191]) + s[47];
gout[22] += + s[42] + (-1*s[114]) + (-1*s[38]) + s[110];
gout[23] += + s[33] + s[123] + s[213] + (-1*s[29]) + (-1*s[119]) + (-1*s[209]);
gout[24] += + s[127] + (-1*s[199]) + (-1*s[129]) + s[201];
gout[25] += + s[190] + (-1*s[46]) + (-1*s[192]) + s[48];
gout[26] += + s[37] + (-1*s[109]) + (-1*s[39]) + s[111];
gout[27] += + s[28] + s[118] + s[208] + (-1*s[30]) + (-1*s[120]) + (-1*s[210]);
gout[28] += + s[126] + (-1*s[198]) + s[130] + (-1*s[202]) + s[134] + (-1*s[206]);
gout[29] += + s[189] + (-1*s[45]) + s[193] + (-1*s[49]) + s[197] + (-1*s[53]);
gout[30] += + s[36] + (-1*s[108]) + s[40] + (-1*s[112]) + s[44] + (-1*s[116]);
gout[31] += + s[27] + s[117] + s[207] + s[31] + s[121] + s[211] + s[35] + s[125] + s[215];
gout[32] += + s[158] + (-1*s[230]) + (-1*s[160]) + s[232];
gout[33] += + s[221] + (-1*s[77]) + (-1*s[223]) + s[79];
gout[34] += + s[68] + (-1*s[140]) + (-1*s[70]) + s[142];
gout[35] += + s[59] + s[149] + s[239] + (-1*s[61]) + (-1*s[151]) + (-1*s[241]);
gout[36] += + s[159] + (-1*s[231]) + (-1*s[155]) + s[227];
gout[37] += + s[222] + (-1*s[78]) + (-1*s[218]) + s[74];
gout[38] += + s[69] + (-1*s[141]) + (-1*s[65]) + s[137];
gout[39] += + s[60] + s[150] + s[240] + (-1*s[56]) + (-1*s[146]) + (-1*s[236]);
gout[40] += + s[154] + (-1*s[226]) + (-1*s[156]) + s[228];
gout[41] += + s[217] + (-1*s[73]) + (-1*s[219]) + s[75];
gout[42] += + s[64] + (-1*s[136]) + (-1*s[66]) + s[138];
gout[43] += + s[55] + s[145] + s[235] + (-1*s[57]) + (-1*s[147]) + (-1*s[237]);
gout[44] += + s[153] + (-1*s[225]) + s[157] + (-1*s[229]) + s[161] + (-1*s[233]);
gout[45] += + s[216] + (-1*s[72]) + s[220] + (-1*s[76]) + s[224] + (-1*s[80]);
gout[46] += + s[63] + (-1*s[135]) + s[67] + (-1*s[139]) + s[71] + (-1*s[143]);
gout[47] += + s[54] + s[144] + s[234] + s[58] + s[148] + s[238] + s[62] + s[152] + s[242];
gout += 48;
}}}
void cint2e_ipsrsr1srsr2_optimizer(CINTOpt **opt, const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env) {
FINT ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTuse_all_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
FINT cint2e_ipsrsr1srsr2(double *opijkl, const FINT *shls,
const FINT *atm, const FINT natm,
const FINT *bas, const FINT nbas, const double *env, CINTOpt *opt) {
FINT ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_cint2e_ipsrsr1srsr2;
envs.common_factor *= 1;
return CINT2e_spinor_drv(opijkl, &envs, opt, &c2s_si_2e1, &c2s_si_2e2);
}
OPTIMIZER2F_(cint2e_ipsrsr1srsr2_optimizer);
C2Fo_(cint2e_ipsrsr1srsr2)
